Models/Album.cs
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace TooJaVile.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations; //lisasin selle osa

    public partial class Album
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public Album()
        {
            this.Photos = new HashSet<Photo>();
            this.Vacations = new HashSet<Vacation>();
        }
    
        public int Id { get; set; }
        public string Name { get; set; }
        public int CreatorId { get; set; }
        public string Description { get; set; }
        public Nullable<int> CoverPictureId { get; set; }
        [DisplayFormat(ApplyFormatInEditMode = true, DataFormatString = "{0:dd.MM.yyyy}")] //Created aja vorming
        public System.DateTime Created { get; set ; }
    
        public virtual Person Person { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Photo> Photos { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Vacation> Vacations { get; set; }
    }
}

Controllers/AlbumsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using TooJaVile.Models;
using System.IO;

namespace TooJaVile.Controllers
{
    [Authorize]
    public class AlbumsController : MyController
    {
        private TooJaVileEntities db = new TooJaVileEntities();

        // GET: Albums
        public ActionResult Index()
        {
            var albums = db.Albums.Include(a => a.Person);
            return View(albums.ToList());
        }

        // GET: Albums/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Album album = db.Albums.Find(id);
            if (album == null)
            {
                return HttpNotFound();
            }
            return View(album);
        }

        // GET: Albums/Create
        public ActionResult Create()
        {
            //Vaatame, kas on vaja
            //CheckPerson();
            //ViewBag.CurrentPerson = CurrentPerson;
            //ViewBag.CreatorId = CurrentPerson.Email;
            //ViewBag.FirstName = CurrentPerson.FirstName;
            //ViewBag.LastName = CurrentPerson.LastName;
            ViewBag.CoverPictureId = new SelectList(db.DataFiles, "Id", "ContentType");


            ViewBag.CreatorId = new SelectList(db.People, "Id", "Email");
            return View();
        }

        // POST: Albums/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Id,Name,CreatorId,Description,CoverPictureId,Created")] Album album, HttpPostedFileBase file)
        {
            //CheckPerson();
            //ViewBag.CurrentPerson = CurrentPerson;
            if (ModelState.IsValid)
            {
                
                    db.Albums.Add(album);
                    db.SaveChanges();


                //siia pildiga toimetamine
                if (file != null && file.ContentLength > 0)
                    using (BinaryReader br = new BinaryReader(file.InputStream)) //see loeb pildifaili sisse
                    {
                        DataFile df = new DataFile
                        {
                            FileName = file.FileName.Split('\\').Last(),
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength),
                            Created = DateTime.Now,
                        };
                        db.DataFiles.Add(df);
                        db.SaveChanges();
                        //selleks et vana pilt kustutada, jätame meelde pildi numbri
                        
                        album.CoverPictureId = df.Id;
                        db.SaveChanges();
                       

                    }

                //siin lõpeb toimetamine pildiga


                return RedirectToAction("Index");
            }
            
            ViewBag.CoverPictureId = new SelectList(db.DataFiles, "Id", "ContentType", album.CoverPictureId);
            //ViewBag.CreatorId = CurrentPerson.Email;
            //ViewBag.FirstName = CurrentPerson.FirstName;
            //ViewBag.LastName = CurrentPerson.LastName;
            ViewBag.CreatorId = new SelectList(db.People, "Id", "Email", album.CreatorId);
            return View(album);
        }

        // GET: Albums/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Album album = db.Albums.Find(id);
            if (album == null)
            {
                return HttpNotFound();
            }
            ViewBag.CreatorId = new SelectList(db.People, "Id", "Email", album.CreatorId);
            return View(album);
        }

        // POST: Albums/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "Id,Name,CreatorId,Description,CoverPictureId,Created")] Album album, HttpPostedFileBase file)
        {
            if (ModelState.IsValid)
            {
                db.Entry(album).State = EntityState.Modified;
                db.Entry(album).Property("CoverPictureId").IsModified = false; //lisasin selle juurde, muidu kustub pilt ära
                db.SaveChanges();


                ChangeDataFile(
                               file,
                               x => { album.CoverPictureId = x; db.SaveChanges(); },
                                album.CoverPictureId);



                //siia pildiga toimetamine
                if (file != null && file.ContentLength > 0)
                    using (BinaryReader br = new BinaryReader(file.InputStream)) //see loeb pildifaili sisse
                    {
                        DataFile df = new DataFile
                        {
                            FileName = file.FileName.Split('\\').Last(),
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength),
                            Created = DateTime.Now,
                        };
                        db.DataFiles.Add(df);
                        db.SaveChanges();
                        //selleks et vana pilt kustutada, jätame meelde pildi numbri
                        int? vanaPiltId = album.CoverPictureId;
                        album.CoverPictureId = df.Id;
                        db.SaveChanges();
                        //siin ei tohi ära kustutada pilte, sest meil on samu pilte mitmes kohas
                        //if (vanaPiltId.HasValue)
                        //{
                        //    db.DataFiles.Remove(db.DataFiles.Find(vanaPiltId.Value));
                        //    db.SaveChanges();
                        //}
                    }

                //siin lõpeb toimetamine pildiga
                return RedirectToAction("Index");
            }
            ViewBag.CreatorId = new SelectList(db.People, "Id", "Email", album.CreatorId);
            return View(album);
        }

        // GET: Albums/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Album album = db.Albums.Find(id);
            if (album == null)
            {
                return HttpNotFound();
            }
            return View(album);
        }

        // POST: Albums/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            Album album = db.Albums.Find(id);
            db.Albums.Remove(album);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Controllers/MyController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;
using TooJaVile.Models;

namespace TooJaVile.Controllers
{
    public class MyController : Controller
    {
        TooJaVileEntities db = new TooJaVileEntities();
        [OutputCache(Duration = 3600, VaryByParam = "id", Location = System.Web.UI.OutputCacheLocation.Any)]
        public ActionResult Content(int? id)
        {
            DataFile df = db.DataFiles.Find(id);
            if (df == null) return HttpNotFound();
            return File(df.Content, df.ContentType);
        }

        //meie veel ei oska checkperson teha
        protected Person CurrentPerson = null; // siis on hea kohe see PersonObject omale taskusse panna
        protected void CheckPerson()
        {
            if (Request.IsAuthenticated)        // kontrollida vaja vaid siis
                if ((CurrentPerson?.Email ?? "") != User.Identity.Name)    // kui juba ei ole meeles või on vale
                {
                    CurrentPerson = db.People.Where(x => x.Email == User.Identity.Name).SingleOrDefault();
                    if (CurrentPerson == null)


                    {
                        using (ApplicationDbContext dba = new ApplicationDbContext())
                        {
                            ApplicationUser u = dba.Users.Where(x => x.Email == User.Identity.Name).SingleOrDefault();
                            db.People.Add(CurrentPerson = new Person
                            {
                                Email = User.Identity.Name,
                                FirstName = u.FirstName,
                                LastName = u.LastName,
                                BirthDate = u.BirthDate
                            });
                            db.SaveChanges();
                        }
                    }
                }
                else CurrentPerson = null;
        }

        protected void ChangeDataFile(HttpPostedFileBase file, Action<int> change, int? oldId)
        {
            if (file != null && file.ContentLength > 0)
                using (BinaryReader br = new BinaryReader(file.InputStream))
                {
                    DataFile df = new DataFile
                    {
                        Content = br.ReadBytes(file.ContentLength),
                        FileName = file.FileName.Split('\\').Last().Split('/').Last(),
                        ContentType = file.ContentType,
                        Created = DateTime.Now
                    };
                    db.DataFiles.Add(df);
                    db.SaveChanges();
                    change(df.Id);
                    if (oldId.HasValue)
                    {
                        db.DataFiles.Remove(db.DataFiles.Find(oldId.Value));
                        db.SaveChanges();
                    }

                }
        }


    }

    public class HomeController : MyController
    {
        public ActionResult Index()
        {
            //CheckPerson();
            return View();
        }
        public ActionResult About()
        {
            ViewBag.Message = "Puhkuste kalender"; //muutsin nime KL

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Puhkuste jäägid"; //muutsin nime KL

            return View();
        }
    }
}

Views/Albums/Create.cshtml
@model TooJaVile.Models.Album

@{
    ViewBag.Title = "Create";
}

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>

    <script>
        function readURL(input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#datafile').attr('src', e.target.result);
                }
                reader.readAsDataURL(input.files[0]);
            }
        }
        $(document).ready(function () {
            $("#file").change(function () {
                readURL(this);
            });
        });</script>
}

<h2>Loo uus album</h2>


@using (Html.BeginForm("Create", "Albums", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()

<div class="form-horizontal">
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    <div class="form-group">
        @Html.LabelFor(model => model.Name, "Nimi", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
            @*@ViewBag.FirstName @ViewBag.LastName*@

            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.CreatorId, "E-mail", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("CreatorId", null, htmlAttributes: new { @class = "form-control"@*, disabled = "disabled"*@ })

            @*@ViewBag.CreatorId*@

            @Html.ValidationMessageFor(model => model.CreatorId, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Description, "Albumi kirjeldus", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
        </div>
    </div>

    @*<div class="form-group">
        @Html.LabelFor(model => model.CoverPictureId, "Vali kaanepilt", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.CoverPictureId, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.CoverPictureId, "", new { @class = "text-danger" })
        </div>
    </div>*@

    <div class="form-group">
        @Html.LabelFor(model => model.CoverPictureId, "Lisa kaanepilt", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.HiddenFor(x => x.CoverPictureId) @*//kui pilt on olemas, siis on on seal ja keegi ei korja seda ära.*@
            <input type="file" name="file" id="file" />
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Created, "Kuupäev", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Created, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Created, "", new { @class = "text-danger" })
            @*@DateTime.Now*@
        </div>
    </div>

    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Loo" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Tagasi nimekirja", "Index")
</div>

Views/Albums/Delete.cshtml
@model TooJaVile.Models.Album

@{
    ViewBag.Title = "Delete";
}

<h2>Kustuta album</h2>

<h3>Kas oled kindel, et soovid kustutada?</h3>
<div>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            Albumi nimi
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        <dt>
            Riik
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

        <dt>
            Album loodud
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Created)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Kustuta" class="btn btn-default" /> |
            @Html.ActionLink("Tagasi albumite nimekirja", "Index")
        </div>
    }
</div>

Views/Albums/Details.cshtml
@model TooJaVile.Models.Album

@{
    ViewBag.Title = "Details";
}

@*<h2>Album</h2>*@
<h2>@Model.Name</h2>
<h3>@Model.Description</h3>
<h3>@Model.Created.Date.ToShortDateString() </h3>


<br />
<p>
    @Html.ActionLink("Muuda albumit", "Edit", new { id = Model.Id }) |
    @Html.ActionLink("Kustuta album", "Delete", new { id = Model.Id }) |
    @Html.ActionLink("Tagasi albumite nimekirja", "Index")
</p>


@*Siia lisasime asjad, et näidata albumi detail vaates selle albumi pilte.*@
@*<h2>Albumi pildid</h2>*@

@*@Html.ActionLink("Create", "Create", "Photos", new { id = Model.Id }, null)*@

@using (Html.BeginForm("Create", "Photos", FormMethod.Post))
{
    <input type="hidden" name="ret" value="@Model.Id" />
    @Html.AntiForgeryToken()
    @Html.Action("Index", "Photos", new { id = Model.Id })
}

Views/Albums/Edit.cshtml
@model TooJaVile.Models.Album

@{
    ViewBag.Title = "Edit";
}
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>

    <script>
        function readURL(input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#datafile').attr('src', e.target.result);
                }
                reader.readAsDataURL(input.files[0]);
            }
        }
        $(document).ready(function () {
            $("#file").change(function () {
                readURL(this);
            });
        });</script>
}

<h2>Muuda albumit</h2>


@using (Html.BeginForm("Edit", "Albums", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()

<div class="form-horizontal">

    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    @Html.HiddenFor(model => model.Id)

    <div class="form-group">
        @Html.LabelFor(model => model.Name, "Albumi nimi", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.CreatorId, "E-mail", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("CreatorId", null, htmlAttributes: new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.CreatorId, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Description, "Riik", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Created, "Kuupäev", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Created, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Created, "", new { @class = "text-danger" })
        </div>
    </div>
    <div class="form-group">
        @Html.LabelFor(model => model.CoverPictureId, "Muuda pilt", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.HiddenFor(x => x.CoverPictureId) @*//kui pilt on olemas, siis on on seal ja keegi ei korja seda ära.*@
            <input type="file" name="file" id="file" />
            <p></p>
            <img src="@Url.Action("Content", "My", new { id=Model.CoverPictureId})" height="120" id="datafile" />
        </div>
    </div>
    @Html.HiddenFor(x => x.CoverPictureId)

    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Salvesta" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Tagasi albumite nimekirja", "Index")
</div>

Views/Albums/Index.cshtml
@model IEnumerable<TooJaVile.Models.Album>

@{
    ViewBag.Title = "Index";
}
<link href="~/Content/Site.css" rel="stylesheet" />
<h2>Pildialbum</h2>

<p>
    @Html.ActionLink("Loo uus album", "Create")
</p>
<style>

    .pilt:hover 
    {
        transition: transform .2s; /* Animation */
        width: 500px;
    }
</style>
<div style="display:flex; flex-wrap:wrap">


    @foreach (var item in Model)
    {
        <div class="gallery pilt">
            <a href='@Url.Action("Details", "Albums", new { id = item.Id })'>
                <img src="@Url.Action("Content", "DataFiles", new {id = item.CoverPictureId})" alt="Cover Picture">
            </a>
            <div class="desc"> @Html.DisplayFor(modelItem => item.Name)</div>
            <div class="desc"> @Html.DisplayFor(modelItem => item.Description)</div>
        </div>
    }
</div>